
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_unsigned.all;

--Entity---------------

ENTITY arlog_unit IS
	PORT (A,B: 	IN STD_LOGIC_VECTOR (7 DOWNTO 0);
		S: 	IN STD_LOGIC_VECTOR (3 DOWNTO 0);
		RESULT: 		OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
		);
END arlog_unit;

--Architecture---------

ARCHITECTURE arch_arlog OF arlog_unit IS
	SIGNAL AR, LOG: 	STD_LOGIC_VECTOR (7 DOWNTO 0);

BEGIN
	
		WITH S(2 DOWNTO 0) SELECT
		LOG <=		a AND b		WHEN "010",
					a OR b		WHEN "011",
					NOT a		WHEN "001",--
					NOT b		WHEN "100",--
					"00000000" 	WHEN OTHERS;

		WITH S(2 DOWNTO 0) SELECT
		AR <=		a+1			WHEN "000",
					b+1			WHEN "010",
					a-1			WHEN "001",--
					b-1			WHEN "011",--
					"00000000" 	WHEN OTHERS; 
		
		WITH S(3) SELECT
		RESULT <= 	LOG WHEN '0',
					AR WHEN OTHERS;
END arch_arlog;

