
LIBRARY ieee;
USE ieee.std_logic_1164.all;

--Entity---------------

 ENTITY ram_mem IS
 
 PORT ( write_enable, clock: IN STD_LOGIC;
 address: IN INTEGER RANGE 0 TO 63;
 data_in: IN STD_LOGIC_VECTOR (7 DOWNTO 0);
 data_out: OUT STD_LOGIC_VECTOR (7 DOWNTO 0));
 END ram_mem;

--Architecture---------

ARCHITECTURE ram OF ram_mem IS
TYPE new_vector IS ARRAY (0 TO 63) OF STD_LOGIC_VECTOR (7 DOWNTO 0);
SIGNAL mem: new_vector;
BEGIN

PROCESS 
	BEGIN
		WAIT UNTIL (clock'EVENT AND clock='1');
		IF (write_enable='1') THEN mem(address) <= data_in;
	END IF;
END PROCESS;

data_out <= mem(address);

END ram;

